package dev.shadowsoffire.apotheosis.ench.objects;

import java.util.Iterator;
import java.util.Map;
import net.minecraft.world.level.ItemLike;
import net.minecraft.world.item.Items;
import net.minecraftforge.registries.ForgeRegistries;
import net.minecraft.world.item.enchantment.Enchantment;
import com.google.common.collect.Lists;
import net.minecraft.util.Mth;
import net.minecraft.world.item.enchantment.EnchantmentHelper;
import net.minecraftforge.event.AnvilUpdateEvent;
import net.minecraft.world.item.Rarity;
import net.minecraftforge.api.distmarker.Dist;
import net.minecraftforge.api.distmarker.OnlyIn;
import net.minecraft.ChatFormatting;
import net.minecraft.world.item.TooltipFlag;
import net.minecraft.network.chat.Component;
import java.util.List;
import net.minecraft.world.level.Level;
import net.minecraft.world.item.ItemStack;
import net.minecraft.world.item.Item;
import java.util.Random;
import net.minecraft.world.item.BookItem;

public class ScrappingTomeItem extends BookItem
{
    static Random rand;
    
    public ScrappingTomeItem() {
        super(new Item.Properties());
    }
    
    public boolean m_8120_(final ItemStack stack) {
        return false;
    }
    
    @OnlyIn(Dist.CLIENT)
    public void m_7373_(final ItemStack stack, final Level world, final List<Component> tooltip, final TooltipFlag flagIn) {
        if (stack.m_41793_()) {
            return;
        }
        tooltip.add((Component)Component.m_237115_("info.apotheosis.scrap_tome").m_130940_(ChatFormatting.GRAY));
        tooltip.add((Component)Component.m_237115_("info.apotheosis.scrap_tome2").m_130940_(ChatFormatting.GRAY));
    }
    
    public Rarity m_41460_(final ItemStack stack) {
        return Rarity.UNCOMMON;
    }
    
    public static boolean updateAnvil(final AnvilUpdateEvent ev) {
        final ItemStack weapon = ev.getLeft();
        final ItemStack book = ev.getRight();
        if (!(book.m_41720_() instanceof ScrappingTomeItem) || book.m_41793_() || !weapon.m_41793_()) {
            return false;
        }
        final Map<Enchantment, Integer> wepEnch = EnchantmentHelper.m_44831_(weapon);
        final int size = Mth.m_14165_(wepEnch.size() / 2.0);
        final List<Enchantment> keys = (List<Enchantment>)Lists.newArrayList((Iterable<?>)wepEnch.keySet());
        long seed = 1831L;
        for (final Enchantment e : keys) {
            seed ^= ForgeRegistries.ENCHANTMENTS.getKey((Object)e).hashCode();
        }
        seed ^= ev.getPlayer().m_36322_();
        ScrappingTomeItem.rand.setSeed(seed);
        while (wepEnch.size() > size) {
            final Enchantment lost = keys.get(ScrappingTomeItem.rand.nextInt(keys.size()));
            wepEnch.remove(lost);
            keys.remove(lost);
        }
        final ItemStack out = new ItemStack((ItemLike)Items.f_42690_);
        EnchantmentHelper.m_44865_((Map)wepEnch, out);
        ev.setMaterialCost(1);
        ev.setCost(wepEnch.size() * 6);
        ev.setOutput(out);
        return true;
    }
    
    static {
        ScrappingTomeItem.rand = new Random();
    }
}
